using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace mp2enc
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class MainWindow : System.Windows.Forms.Form
	{
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Button in_button;
		private System.Windows.Forms.Button out_button;
		private System.Windows.Forms.ProgressBar progressBar;
		private System.Windows.Forms.Button cnv_button;
		private System.Windows.Forms.Button about_button;
		private System.Windows.Forms.TextBox in_textBox;
		private System.Windows.Forms.TextBox out_textBox;
		private System.Windows.Forms.ComboBox mode_comboBox;
		private System.Windows.Forms.DomainUpDown psy_UpDown;
		private System.Windows.Forms.DomainUpDown br_UpDown;
		private System.Windows.Forms.RadioButton ver_mp1_radioButton;
		private System.Windows.Forms.RadioButton ver_mp2_radioButton;
		private System.Windows.Forms.RadioButton pad_no_radioButton;
		private System.Windows.Forms.RadioButton pad_all_radioButton;
		private System.Windows.Forms.CheckBox crc_checkBox;
		private System.Windows.Forms.CheckBox copy_checkBox;
		private System.Windows.Forms.CheckBox orig_checkBox;
		private System.Windows.Forms.CheckBox quick_checkBox;
		private System.Windows.Forms.Label fileinfo_label;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button exit_button;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ToolTip toolTip;
		private System.Windows.Forms.GroupBox in_groupBox;
		private System.Windows.Forms.GroupBox out_groupBox;
		private System.Windows.Forms.GroupBox setting_groupBox;
		private System.Windows.Forms.GroupBox pad_groupBox;
		private System.Windows.Forms.GroupBox ver_groupBox;
		private System.Windows.Forms.GroupBox finfo_groupBox;

		private string outputfile;
		private string inputfile;
		Encoder enc;
		EncProp encp;

		public MainWindow()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			// default param
			int idx;
			idx = mode_comboBox.FindString("AUTO");
			mode_comboBox.SelectedIndex = idx;
			idx = psy_UpDown.Items.IndexOf("Model 3");
			psy_UpDown.SelectedIndex = idx;
			br_UpDown.Text = "default";
			ver_mp1_radioButton.Checked = true;
			pad_no_radioButton.Checked = true;

			// GR[_
			enc = new Encoder(
				new ProgressCallback(cbProgress),
				new FinishedCallback(cbFinished) );
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.progressBar = new System.Windows.Forms.ProgressBar();
			this.in_groupBox = new System.Windows.Forms.GroupBox();
			this.in_textBox = new System.Windows.Forms.TextBox();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.in_button = new System.Windows.Forms.Button();
			this.out_button = new System.Windows.Forms.Button();
			this.cnv_button = new System.Windows.Forms.Button();
			this.about_button = new System.Windows.Forms.Button();
			this.out_groupBox = new System.Windows.Forms.GroupBox();
			this.out_textBox = new System.Windows.Forms.TextBox();
			this.setting_groupBox = new System.Windows.Forms.GroupBox();
			this.pad_groupBox = new System.Windows.Forms.GroupBox();
			this.pad_no_radioButton = new System.Windows.Forms.RadioButton();
			this.pad_all_radioButton = new System.Windows.Forms.RadioButton();
			this.ver_groupBox = new System.Windows.Forms.GroupBox();
			this.ver_mp1_radioButton = new System.Windows.Forms.RadioButton();
			this.ver_mp2_radioButton = new System.Windows.Forms.RadioButton();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.quick_checkBox = new System.Windows.Forms.CheckBox();
			this.orig_checkBox = new System.Windows.Forms.CheckBox();
			this.copy_checkBox = new System.Windows.Forms.CheckBox();
			this.crc_checkBox = new System.Windows.Forms.CheckBox();
			this.br_UpDown = new System.Windows.Forms.DomainUpDown();
			this.psy_UpDown = new System.Windows.Forms.DomainUpDown();
			this.mode_comboBox = new System.Windows.Forms.ComboBox();
			this.finfo_groupBox = new System.Windows.Forms.GroupBox();
			this.fileinfo_label = new System.Windows.Forms.Label();
			this.exit_button = new System.Windows.Forms.Button();
			this.toolTip = new System.Windows.Forms.ToolTip(this.components);
			this.in_groupBox.SuspendLayout();
			this.out_groupBox.SuspendLayout();
			this.setting_groupBox.SuspendLayout();
			this.pad_groupBox.SuspendLayout();
			this.ver_groupBox.SuspendLayout();
			this.finfo_groupBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// progressBar
			// 
			this.progressBar.Location = new System.Drawing.Point(16, 296);
			this.progressBar.Name = "progressBar";
			this.progressBar.Size = new System.Drawing.Size(456, 23);
			this.progressBar.TabIndex = 0;
			// 
			// in_groupBox
			// 
			this.in_groupBox.Controls.Add(this.in_textBox);
			this.in_groupBox.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.in_groupBox.Location = new System.Drawing.Point(16, 8);
			this.in_groupBox.Name = "in_groupBox";
			this.in_groupBox.Size = new System.Drawing.Size(368, 48);
			this.in_groupBox.TabIndex = 5;
			this.in_groupBox.TabStop = false;
			this.in_groupBox.Text = "Input file";
			// 
			// in_textBox
			// 
			this.in_textBox.AutoSize = false;
			this.in_textBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.in_textBox.Cursor = System.Windows.Forms.Cursors.Default;
			this.in_textBox.Location = new System.Drawing.Point(8, 16);
			this.in_textBox.Multiline = true;
			this.in_textBox.Name = "in_textBox";
			this.in_textBox.ReadOnly = true;
			this.in_textBox.Size = new System.Drawing.Size(352, 24);
			this.in_textBox.TabIndex = 0;
			this.in_textBox.TabStop = false;
			this.in_textBox.Text = "N/A";
			this.toolTip.SetToolTip(this.in_textBox, "Input file path.");
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.DefaultExt = "wav";
			this.openFileDialog1.Filter = "wave files (*.wav)|*.wav|All files (*.*)|*.*";
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.DefaultExt = "mp2";
			this.saveFileDialog1.Filter = "MPEG Audio LayerII (*.mp2;*.mpa)|*.mp2;*.mpa";
			// 
			// in_button
			// 
			this.in_button.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.in_button.Location = new System.Drawing.Point(400, 24);
			this.in_button.Name = "in_button";
			this.in_button.Size = new System.Drawing.Size(75, 24);
			this.in_button.TabIndex = 0;
			this.in_button.Text = "input file";
			this.toolTip.SetToolTip(this.in_button, "Open input file.");
			this.in_button.Click += new System.EventHandler(this.in_button_Click);
			// 
			// out_button
			// 
			this.out_button.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.out_button.Location = new System.Drawing.Point(400, 80);
			this.out_button.Name = "out_button";
			this.out_button.TabIndex = 1;
			this.out_button.Text = "output file";
			this.toolTip.SetToolTip(this.out_button, "Set output file.");
			this.out_button.Click += new System.EventHandler(this.out_button_Click);
			// 
			// cnv_button
			// 
			this.cnv_button.Enabled = false;
			this.cnv_button.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.cnv_button.Location = new System.Drawing.Point(400, 176);
			this.cnv_button.Name = "cnv_button";
			this.cnv_button.TabIndex = 2;
			this.cnv_button.Text = "convert";
			this.toolTip.SetToolTip(this.cnv_button, "Proceed/Abort encoding.");
			this.cnv_button.Click += new System.EventHandler(this.cnv_button_Click);
			// 
			// about_button
			// 
			this.about_button.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.about_button.Location = new System.Drawing.Point(400, 216);
			this.about_button.Name = "about_button";
			this.about_button.TabIndex = 3;
			this.about_button.Text = "about";
			this.toolTip.SetToolTip(this.about_button, "About this program.");
			this.about_button.Click += new System.EventHandler(this.about_button_Click);
			// 
			// out_groupBox
			// 
			this.out_groupBox.Controls.Add(this.out_textBox);
			this.out_groupBox.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.out_groupBox.Location = new System.Drawing.Point(16, 64);
			this.out_groupBox.Name = "out_groupBox";
			this.out_groupBox.Size = new System.Drawing.Size(368, 48);
			this.out_groupBox.TabIndex = 6;
			this.out_groupBox.TabStop = false;
			this.out_groupBox.Text = "Output file";
			// 
			// out_textBox
			// 
			this.out_textBox.AutoSize = false;
			this.out_textBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.out_textBox.Cursor = System.Windows.Forms.Cursors.Default;
			this.out_textBox.Location = new System.Drawing.Point(8, 16);
			this.out_textBox.Multiline = true;
			this.out_textBox.Name = "out_textBox";
			this.out_textBox.ReadOnly = true;
			this.out_textBox.Size = new System.Drawing.Size(352, 24);
			this.out_textBox.TabIndex = 0;
			this.out_textBox.TabStop = false;
			this.out_textBox.Text = "N/A";
			this.toolTip.SetToolTip(this.out_textBox, "Output file path.");
			// 
			// setting_groupBox
			// 
			this.setting_groupBox.Controls.Add(this.pad_groupBox);
			this.setting_groupBox.Controls.Add(this.ver_groupBox);
			this.setting_groupBox.Controls.Add(this.label3);
			this.setting_groupBox.Controls.Add(this.label2);
			this.setting_groupBox.Controls.Add(this.label1);
			this.setting_groupBox.Controls.Add(this.quick_checkBox);
			this.setting_groupBox.Controls.Add(this.orig_checkBox);
			this.setting_groupBox.Controls.Add(this.copy_checkBox);
			this.setting_groupBox.Controls.Add(this.crc_checkBox);
			this.setting_groupBox.Controls.Add(this.br_UpDown);
			this.setting_groupBox.Controls.Add(this.psy_UpDown);
			this.setting_groupBox.Controls.Add(this.mode_comboBox);
			this.setting_groupBox.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.setting_groupBox.Location = new System.Drawing.Point(16, 168);
			this.setting_groupBox.Name = "setting_groupBox";
			this.setting_groupBox.Size = new System.Drawing.Size(368, 120);
			this.setting_groupBox.TabIndex = 8;
			this.setting_groupBox.TabStop = false;
			this.setting_groupBox.Text = "Settings";
			// 
			// pad_groupBox
			// 
			this.pad_groupBox.Controls.Add(this.pad_no_radioButton);
			this.pad_groupBox.Controls.Add(this.pad_all_radioButton);
			this.pad_groupBox.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.pad_groupBox.Location = new System.Drawing.Point(168, 8);
			this.pad_groupBox.Name = "pad_groupBox";
			this.pad_groupBox.Size = new System.Drawing.Size(192, 40);
			this.pad_groupBox.TabIndex = 6;
			this.pad_groupBox.TabStop = false;
			this.pad_groupBox.Text = "Padding";
			this.toolTip.SetToolTip(this.pad_groupBox, "Set frame padding for the output stream.");
			// 
			// pad_no_radioButton
			// 
			this.pad_no_radioButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.pad_no_radioButton.Location = new System.Drawing.Point(8, 16);
			this.pad_no_radioButton.Name = "pad_no_radioButton";
			this.pad_no_radioButton.Size = new System.Drawing.Size(88, 16);
			this.pad_no_radioButton.TabIndex = 0;
			this.pad_no_radioButton.Text = "No Padding";
			// 
			// pad_all_radioButton
			// 
			this.pad_all_radioButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.pad_all_radioButton.Location = new System.Drawing.Point(96, 16);
			this.pad_all_radioButton.Name = "pad_all_radioButton";
			this.pad_all_radioButton.Size = new System.Drawing.Size(88, 16);
			this.pad_all_radioButton.TabIndex = 1;
			this.pad_all_radioButton.Text = "Padding All";
			// 
			// ver_groupBox
			// 
			this.ver_groupBox.Controls.Add(this.ver_mp1_radioButton);
			this.ver_groupBox.Controls.Add(this.ver_mp2_radioButton);
			this.ver_groupBox.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ver_groupBox.Location = new System.Drawing.Point(168, 48);
			this.ver_groupBox.Name = "ver_groupBox";
			this.ver_groupBox.Size = new System.Drawing.Size(192, 40);
			this.ver_groupBox.TabIndex = 7;
			this.ver_groupBox.TabStop = false;
			this.ver_groupBox.Text = "MPEG Version(Auto Select)";
			this.toolTip.SetToolTip(this.ver_groupBox, "MPEG version of the audio stream.(Not selectable)");
			// 
			// ver_mp1_radioButton
			// 
			this.ver_mp1_radioButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ver_mp1_radioButton.Location = new System.Drawing.Point(8, 16);
			this.ver_mp1_radioButton.Name = "ver_mp1_radioButton";
			this.ver_mp1_radioButton.Size = new System.Drawing.Size(64, 16);
			this.ver_mp1_radioButton.TabIndex = 0;
			this.ver_mp1_radioButton.Text = "MPEG1";
			// 
			// ver_mp2_radioButton
			// 
			this.ver_mp2_radioButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ver_mp2_radioButton.Location = new System.Drawing.Point(96, 16);
			this.ver_mp2_radioButton.Name = "ver_mp2_radioButton";
			this.ver_mp2_radioButton.Size = new System.Drawing.Size(64, 16);
			this.ver_mp2_radioButton.TabIndex = 1;
			this.ver_mp2_radioButton.Text = "MPEG2";
			// 
			// label3
			// 
			this.label3.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label3.Location = new System.Drawing.Point(8, 68);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(72, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Bitrate(kbps)";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.toolTip.SetToolTip(this.label3, "Set bitrate");
			// 
			// label2
			// 
			this.label2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label2.Location = new System.Drawing.Point(8, 45);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "Psy Model";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.toolTip.SetToolTip(this.label2, "Set Psychoacoustic Model.");
			// 
			// label1
			// 
			this.label1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label1.Location = new System.Drawing.Point(8, 22);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "MODE";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.toolTip.SetToolTip(this.label1, "Set Audio Mode (Mono, Stereo, etc).");
			// 
			// quick_checkBox
			// 
			this.quick_checkBox.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.quick_checkBox.Location = new System.Drawing.Point(16, 96);
			this.quick_checkBox.Name = "quick_checkBox";
			this.quick_checkBox.Size = new System.Drawing.Size(88, 16);
			this.quick_checkBox.TabIndex = 8;
			this.quick_checkBox.Text = "Quick Mode";
			this.toolTip.SetToolTip(this.quick_checkBox, "Enable/Disable quick mode for psycho model calculation.");
			// 
			// orig_checkBox
			// 
			this.orig_checkBox.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.orig_checkBox.Location = new System.Drawing.Point(296, 96);
			this.orig_checkBox.Name = "orig_checkBox";
			this.orig_checkBox.Size = new System.Drawing.Size(64, 16);
			this.orig_checkBox.TabIndex = 11;
			this.orig_checkBox.Text = "Original";
			this.toolTip.SetToolTip(this.orig_checkBox, "Set Original flag.");
			// 
			// copy_checkBox
			// 
			this.copy_checkBox.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.copy_checkBox.Location = new System.Drawing.Point(224, 96);
			this.copy_checkBox.Name = "copy_checkBox";
			this.copy_checkBox.Size = new System.Drawing.Size(72, 16);
			this.copy_checkBox.TabIndex = 10;
			this.copy_checkBox.Text = "Copylight";
			this.toolTip.SetToolTip(this.copy_checkBox, "Set Copyright flag.");
			// 
			// crc_checkBox
			// 
			this.crc_checkBox.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.crc_checkBox.Location = new System.Drawing.Point(168, 96);
			this.crc_checkBox.Name = "crc_checkBox";
			this.crc_checkBox.Size = new System.Drawing.Size(48, 16);
			this.crc_checkBox.TabIndex = 9;
			this.crc_checkBox.Text = "CRC";
			this.toolTip.SetToolTip(this.crc_checkBox, "Enable/Disable CRC Error detection.");
			// 
			// br_UpDown
			// 
			this.br_UpDown.Items.Add("384");
			this.br_UpDown.Items.Add("320");
			this.br_UpDown.Items.Add("256");
			this.br_UpDown.Items.Add("224");
			this.br_UpDown.Items.Add("192");
			this.br_UpDown.Items.Add("160");
			this.br_UpDown.Items.Add("128");
			this.br_UpDown.Items.Add("112");
			this.br_UpDown.Items.Add("96");
			this.br_UpDown.Items.Add("80");
			this.br_UpDown.Items.Add("64");
			this.br_UpDown.Items.Add("56");
			this.br_UpDown.Items.Add("48");
			this.br_UpDown.Items.Add("32");
			this.br_UpDown.Items.Add("16");
			this.br_UpDown.Items.Add("8");
			this.br_UpDown.Location = new System.Drawing.Point(80, 64);
			this.br_UpDown.Name = "br_UpDown";
			this.br_UpDown.ReadOnly = true;
			this.br_UpDown.Size = new System.Drawing.Size(80, 19);
			this.br_UpDown.TabIndex = 5;
			this.br_UpDown.Text = "n/a";
			this.br_UpDown.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// psy_UpDown
			// 
			this.psy_UpDown.Items.Add("Model 4");
			this.psy_UpDown.Items.Add("Model 3");
			this.psy_UpDown.Items.Add("Model 2");
			this.psy_UpDown.Items.Add("Model 1");
			this.psy_UpDown.Items.Add("Model 0");
			this.psy_UpDown.Items.Add("Model -1");
			this.psy_UpDown.Location = new System.Drawing.Point(80, 40);
			this.psy_UpDown.Name = "psy_UpDown";
			this.psy_UpDown.ReadOnly = true;
			this.psy_UpDown.Size = new System.Drawing.Size(80, 19);
			this.psy_UpDown.TabIndex = 3;
			this.psy_UpDown.Text = "n/a";
			this.psy_UpDown.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// mode_comboBox
			// 
			this.mode_comboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.mode_comboBox.Items.AddRange(new object[] {
															   "AUTO",
															   "STEREO",
															   "JOINT_STEREO",
															   "DUAL_CHANNEL",
															   "MONO"});
			this.mode_comboBox.Location = new System.Drawing.Point(48, 16);
			this.mode_comboBox.Name = "mode_comboBox";
			this.mode_comboBox.Size = new System.Drawing.Size(112, 20);
			this.mode_comboBox.TabIndex = 1;
			// 
			// finfo_groupBox
			// 
			this.finfo_groupBox.Controls.Add(this.fileinfo_label);
			this.finfo_groupBox.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.finfo_groupBox.Location = new System.Drawing.Point(16, 120);
			this.finfo_groupBox.Name = "finfo_groupBox";
			this.finfo_groupBox.Size = new System.Drawing.Size(368, 40);
			this.finfo_groupBox.TabIndex = 7;
			this.finfo_groupBox.TabStop = false;
			this.finfo_groupBox.Text = "File info";
			this.toolTip.SetToolTip(this.finfo_groupBox, "Input file information.");
			// 
			// fileinfo_label
			// 
			this.fileinfo_label.AutoSize = true;
			this.fileinfo_label.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.fileinfo_label.Location = new System.Drawing.Point(16, 16);
			this.fileinfo_label.Name = "fileinfo_label";
			this.fileinfo_label.Size = new System.Drawing.Size(26, 15);
			this.fileinfo_label.TabIndex = 0;
			this.fileinfo_label.Text = "N/A";
			this.fileinfo_label.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// exit_button
			// 
			this.exit_button.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.exit_button.Location = new System.Drawing.Point(400, 256);
			this.exit_button.Name = "exit_button";
			this.exit_button.TabIndex = 4;
			this.exit_button.Text = "exit";
			this.toolTip.SetToolTip(this.exit_button, "Exit mp2enc.");
			this.exit_button.Click += new System.EventHandler(this.exit_button_Click);
			// 
			// toolTip
			// 
			this.toolTip.ShowAlways = true;
			// 
			// MainWindow
			// 
			this.AcceptButton = this.exit_button;
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(490, 327);
			this.Controls.Add(this.exit_button);
			this.Controls.Add(this.finfo_groupBox);
			this.Controls.Add(this.setting_groupBox);
			this.Controls.Add(this.about_button);
			this.Controls.Add(this.cnv_button);
			this.Controls.Add(this.in_groupBox);
			this.Controls.Add(this.progressBar);
			this.Controls.Add(this.out_button);
			this.Controls.Add(this.in_button);
			this.Controls.Add(this.out_groupBox);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "MainWindow";
			this.Text = "mp2enc";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MainWindow_Closing);
			this.DragDrop += new System.Windows.Forms.DragEventHandler(this.MainWindow_DragDrop);
			this.DragEnter += new System.Windows.Forms.DragEventHandler(this.MainWindow_DragEnter);
			this.in_groupBox.ResumeLayout(false);
			this.out_groupBox.ResumeLayout(false);
			this.setting_groupBox.ResumeLayout(false);
			this.pad_groupBox.ResumeLayout(false);
			this.ver_groupBox.ResumeLayout(false);
			this.finfo_groupBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			Application.DoEvents();
			Application.Run(new MainWindow());
		}

		/// <summary>
		/// ̓t@CJۂɌĂяo
		/// t@CtH[}bg𒲂ׁAΉĂ
		/// this.inputfile ɃpX
		/// </summary>
		/// <param name="file">t@Cւ̃pX</param>
		private void on_open_inputfile(string file)
		{
			if(System.IO.File.Exists(file))
			{
				WaveReader rd = new WaveReader();
				if(rd.Open(file))
				{
					if(16000 != rd.SamplesPerSec && 22050 != rd.SamplesPerSec
						&& 24000 != rd.SamplesPerSec && 32000 != rd.SamplesPerSec
						&& 44100 != rd.SamplesPerSec && 48000 != rd.SamplesPerSec)
					{
						// ΉĂȂTv[g
						MessageBox.Show("Unsupported Sample rate.", "File Open Error",
							MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					}
					else if(rd.BitsPerSample != 16)
					{
						// 16bit/samplêݑΉ
						MessageBox.Show("Supports only 16bit/sample PCM.", "File Open Error",
							MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					}
					else if(rd.Channel != 1 && rd.Channel != 2)
					{
						// 1 or 2ch ̂ݑΉ
						MessageBox.Show("Supports only 1or2Ch PCM.", "File Open Error",
							MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					}
					else //open successfully
					{
						open_succeeded(rd);
						inputfile = file;
						in_textBox.Text = inputfile;
						if(outputfile == null)
						{
							// o̓t@CftHglɐݒ
							int idx = inputfile.LastIndexOf('.');
							if(idx>0 && idx>inputfile.LastIndexOf('\\'))
							{ 
								outputfile = inputfile.Substring(0, idx) + ".mp2";
							}
							else
							{
								outputfile = inputfile + ".mp2";
							}
							out_textBox.Text = outputfile;
						}
					}
					rd.Close();
				}
				else
				{
					// Wavet@Cł͂Ȃ
					MessageBox.Show("Not WAVE file.", "File Open Error",
						MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				}
			}
			else
			{
				//t@C݂Ȃ
				MessageBox.Show("File not exists.", "File Open Error",
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
		}

		/// <summary>
		/// t@C̃I[vɐꍇɌĂяo
		/// GR[_Aꕔ̃p[^ݒB
		/// p[^𓾂ĕ\
		/// </summary>
		/// <param name="rd">JĂt@C̃[_(WaveƊmFς)</param>
		private void open_succeeded(WaveReader rd)
		{
			// vOXo[̐ݒ
			progressBar.Minimum = 0;
			progressBar.Maximum = (int)rd.Length;
			progressBar.Value = 0;

			// ̓t@C̏\
			fileinfo_label.Text  = "Fs: " + rd.SamplesPerSec.ToString() + "Hz  Ch: ";
			fileinfo_label.Text += rd.Channel.ToString() + "  Samples: ";
			fileinfo_label.Text += (rd.Length/(rd.BitsPerSample*rd.Channel/8));
			fileinfo_label.Text += "(" + rd.Length/rd.AvgBytesPerSec + "sec)";

			// GR[_Ap[^𓾂ĕ\
			enc.Init(rd);
			encp = enc.GetEncProps();
			DispSettings();

			//convert{^L
			cnv_button.Enabled = true;
		}

		/// <summary>
		/// ݂̃GR[_p[^\
		/// this.encp ɕ\
		/// </summary>
		private void DispSettings()
		{
			int id;

			//Mode
			if(encp.MPEG_mode == Twolame.MPEG_mode.AUTO_MODE)
				id = mode_comboBox.FindString("AUTO");
			else if(encp.MPEG_mode == Twolame.MPEG_mode.JOINT_STEREO)
				id = mode_comboBox.FindString("JOINT_STEREO");
			else if(encp.MPEG_mode == Twolame.MPEG_mode.DUAL_CHANNEL)
				id = mode_comboBox.FindString("DUAL_CHANNEL");
			else if(encp.MPEG_mode == Twolame.MPEG_mode.MONO)
				id = mode_comboBox.FindString("MONO");
			else if(encp.MPEG_mode == Twolame.MPEG_mode.STEREO)
				id = mode_comboBox.FindString("STEREO");
			else 
				id = 0;

			mode_comboBox.SelectedIndex = id;

			//Psy MODEL;
			psy_UpDown.SelectedIndex = psy_UpDown.Items.IndexOf("Model " + encp.Psymodel.ToString());
			
			//Bitrate
			if(encp.Bitrate < 0)
				br_UpDown.Text = "default";
			else
				br_UpDown.SelectedIndex = br_UpDown.Items.IndexOf(encp.Bitrate.ToString());

			//Padding
			if(encp.Padding == Twolame.Padding.PAD_NO)
				pad_no_radioButton.Checked = true;
			else
				pad_all_radioButton.Checked = true;

			//MPEG Ver
			if(encp.MPEG_version == Twolame.MPEG_version.MPEG2)
				ver_mp2_radioButton.Checked = true;
			else
				ver_mp1_radioButton.Checked = true;


			//Quick mode
			quick_checkBox.Checked = encp.Quick_mode;

			//CRC
			crc_checkBox.Checked = encp.CRC;

			//Copy
			copy_checkBox.Checked = encp.Copyright;

			//Orig
			orig_checkBox.Checked = encp.Original;
		}
		
		/// <summary>
		/// ݕ\Ăݒ𓾂
		/// this.encp Ɋi[
		/// </summary>
		private void GetSettings()
		{
			//Mode
			string str = (string)mode_comboBox.SelectedItem;
			if(str == "AUTO")
				encp.MPEG_mode = Twolame.MPEG_mode.AUTO_MODE;
			else if(str == "MONO" || encp.Num_channels == 1)
				encp.MPEG_mode = Twolame.MPEG_mode.MONO;
			else if(str == "JOINT_STEREO")
				encp.MPEG_mode = Twolame.MPEG_mode.JOINT_STEREO;
			else if(str == "DUAL_CHANNEL")
				encp.MPEG_mode = Twolame.MPEG_mode.DUAL_CHANNEL;
			else if(str == "STEREO")
				encp.MPEG_mode = Twolame.MPEG_mode.STEREO;

			//Psy MODEL;
			encp.Psymodel = Int32.Parse(psy_UpDown.Text.Remove(0, "Model ".Length));
			
			//MPEG Ver
			if(encp.InSamplerate >= 32000)
				encp.MPEG_version = Twolame.MPEG_version.MPEG1;
			else
				encp.MPEG_version = Twolame.MPEG_version.MPEG2;

			//Bitrate
			if(br_UpDown.Text == "default")
				encp.Bitrate = -1; //Auto
			else
				encp.Bitrate = Int32.Parse(br_UpDown.Text);

			if(encp.Bitrate > 0) //limit bitrate
			{
				if(encp.Num_channels == 2)
				{
					if(encp.MPEG_version == Twolame.MPEG_version.MPEG1)
					{
						if(encp.Bitrate < 64) encp.Bitrate = 64;
					}
					else
					{
						if(encp.Bitrate < 16) encp.Bitrate = 16;
						else if(encp.Bitrate > 160) encp.Bitrate = 160;
					}
				}
				else if(encp.Num_channels == 1)
				{
					if(encp.MPEG_version == Twolame.MPEG_version.MPEG1)
					{
						if(encp.Bitrate < 32) encp.Bitrate = 32;
						else if(encp.Bitrate > 192) encp.Bitrate = 192;
					}
					else
					{
						if(encp.Bitrate > 80) encp.Bitrate = 80;
					}
				}
			}

			//Padding
			if(pad_no_radioButton.Checked)
				encp.Padding = Twolame.Padding.PAD_NO;
			else
				encp.Padding = Twolame.Padding.PAD_ALL;

			//Quick mode
			encp.Quick_mode = quick_checkBox.Checked;

			//CRC
			encp.CRC = crc_checkBox.Checked;

			//Copy
			encp.Copyright = copy_checkBox.Checked;

			//Orig
			encp.Original = orig_checkBox.Checked;
		}

		/// <summary>
		/// 󋵒ʒmp̃R[obN
		/// </summary>
		/// <param name="inc">oCg</param>
		public void cbProgress(int inc)
		{
			// vOXo[i߂
			progressBar.Increment(inc);
		}

		/// <summary>
		/// IʒmpR[obN
		/// </summary>
		/// <param name="ob">R[obNĂяoIuWFNg</param>
		public void cbFinished(object ob)
		{
			// f{^̂Ɠlɏ
			abort_button_Click(ob, new System.EventArgs());
		}

		/// "input file"{^
		private void in_button_Click(object sender, System.EventArgs e)
		{
			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				on_open_inputfile(openFileDialog1.FileName);
			}
		}

		/// "output file"{^
		private void out_button_Click(object sender, System.EventArgs e)
		{
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				outputfile = saveFileDialog1.FileName;
				out_textBox.Text = outputfile;
			}
		}

		/// D&Dsꂽꍇ̏
		private void MainWindow_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			// Ensure that the list item index is contained in the data.
			if (e.Data.GetDataPresent(DataFormats.FileDrop))
			{
				string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
				on_open_inputfile(files[0]);
			}
		}

		/// EChDɃt@ChbOꂽꍇ
		private void MainWindow_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			// If the data is a file or a bitmap, display the copy cursor.
			if (e.Data.GetDataPresent(DataFormats.FileDrop)) 
			{
				e.Effect = DragDropEffects.Copy;
			}
			else
			{
				e.Effect = DragDropEffects.None;
			}

		}

		/// "convert"{^
		private void cnv_button_Click(object sender, System.EventArgs e)
		{
			//file isn't opened
			if(inputfile == null || outputfile == null || enc == null)
			{
				return;
			}

			GetSettings();

			lock(enc)
			{
				if(!enc.InitParams(ref encp))
				{
					// p[^Ɏs
					MessageBox.Show("Wrong settings.", "Encode Settings Error",
						MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

					// Hp[^𕜋A
					encp = enc.GetEncProps();
					DispSettings();

					return;
				}
				encp = enc.GetEncProps();
				DispSettings();

				//block events
				in_button.Enabled = false;
				out_button.Enabled = false;
				exit_button.Enabled = false;
				setting_groupBox.Enabled = false;
				cnv_button.Text = "abort";
				this.DragDrop -= new System.Windows.Forms.DragEventHandler(this.MainWindow_DragDrop);
				this.DragEnter -= new System.Windows.Forms.DragEventHandler(this.MainWindow_DragEnter);
				this.cnv_button.Click -= new System.EventHandler(cnv_button_Click);
				this.cnv_button.Click += new System.EventHandler(abort_button_Click);

				progressBar.Value = progressBar.Minimum;

				if(!enc.Start(inputfile, outputfile))
				{
					// GR[hJns
					MessageBox.Show("Ecode Start Failed.", "Encode Error",
						MessageBoxButtons.OK, MessageBoxIcon.Error);

					// {^̏Ԃ𕜋A
					cbFinished(null);
				}
			}
		}

		/// "abort"{^
		private void abort_button_Click(object sender, System.EventArgs e)
		{
			lock(enc)
			{
				// łɕAIĂ
				if(cnv_button.Text == "convert") return;

				if(sender == cnv_button)
				{
					// {"abort"{^ꂽꍇ̓GR[_𒆒f
					enc.Abort();
					progressBar.Value = progressBar.Minimum;
				}

				// ubNCxgɖ߂
				in_button.Enabled = true;
				out_button.Enabled = true;
				exit_button.Enabled = true;
				setting_groupBox.Enabled = true;
				cnv_button.Text = "convert";
				this.DragDrop += new System.Windows.Forms.DragEventHandler(this.MainWindow_DragDrop);
				this.DragEnter += new System.Windows.Forms.DragEventHandler(this.MainWindow_DragEnter);
				this.cnv_button.Click -= new System.EventHandler(abort_button_Click);
				this.cnv_button.Click += new System.EventHandler(cnv_button_Click);
			}
		}

		/// "about"{^
		private void about_button_Click(object sender, System.EventArgs e)
		{
			new About().ShowDialog();
		}

		/// "exit"{^
		private void exit_button_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		/// <summary>
		/// ͏IȂ
		/// </summary>
		private void MainWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			// Determine if text has changed in the textbox by comparing to original text.
			if(enc.IsRunning())
			{
				// Display a MsgBox asking the user to exit or abort.
				if(MessageBox.Show("encoder still runnning. realy exit?", "Now Encoding",
					MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) ==  DialogResult.No)
				{
					// Cancel the Closing event from closing the form.
					e.Cancel = true;
				}
				else
				{
					enc.Abort();
				}
			}

		}

	}
}
